stages:
  - validate
  - apply
  - destroy

image:
  name: hashicorp/terraform:latest
  entrypoint:
    - /usr/bin/env
    - "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"

variables:
  TF_ROOT_DIR: "."
  TF_HTTP_ADDRESS: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state/${CI_PROJECT_ID}"
  TF_HTTP_LOCK_ADDRESS: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state/${CI_PROJECT_ID}/lock"
  TF_HTTP_LOCK_METHOD: POST
  TF_HTTP_UNLOCK_ADDRESS: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state/${CI_PROJECT_ID}/lock"
  TF_HTTP_UNLOCK_METHOD: DELETE
  TF_HTTP_USERNAME: gitlab-ci-token
  TF_HTTP_PASSWORD: "${CI_JOB_TOKEN}"
  TF_HTTP_RETRY_WAIT_MIN: "5"

cache:
  key: tf-env
  paths:
    - .terraform

before_script:
  - terraform -chdir=${TF_ROOT_DIR} init -input=false

tf:validate:
  stage: validate
  script:
    - terraform -chdir=${TF_ROOT_DIR} fmt -check -diff
    - terraform -chdir=${TF_ROOT_DIR} validate

tf:apply:
  stage: apply
  when: manual
  only:
    - main
  script:
    - terraform -chdir=${TF_ROOT_DIR} apply -input=false -auto-approve

tf:destroy:
  stage: destroy
  when: manual
  only:
    - main
  script:
    - terraform -chdir=${TF_ROOT_DIR} destroy -input=false -auto-approve
